using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

using Microsoft.DirectX;
using Microsoft.DirectX.Direct3D;

namespace Quiz
{
    public partial class Canvas : Form
    {
        /// <summary>
        /// Direct3D foCX
        /// </summary>
        private Device device = null;
        private PresentParameters presentParameters = null;

        // L\[X
        private Microsoft.DirectX.Direct3D.Font font = null;
        private Texture diffTex = null;

        private Mesh boxMesh = null;
        private Effect effect = null;

        public Canvas()
        {
            InitializeComponent();
            // ɍĕ`悷邽߂̂܂Ȃ
            this.SetStyle(ControlStyles.AllPaintingInWmPaint | ControlStyles.Opaque, true);
        }

        /// <summary>
        /// CanvasꂽƂ
        /// </summary>
        protected override void OnClosed(EventArgs e)
        {
            // foCXJ
            TerminateGraphics();

            base.OnClosed(e);
        }

        /// <summary>
        /// OtBbNX֘Ã\[X
        /// </summary>
        public void InitializeGraphics(bool bWindowed)
        {
            presentParameters = new PresentParameters();
            //  ȉApresentParameters̐ݒ肪iIj
            #region
            presentParameters.Windowed = bWindowed;
            if (bWindowed == false)
            {
                presentParameters.BackBufferWidth = this.ClientSize.Width;
                presentParameters.BackBufferHeight = this.ClientSize.Height;
                presentParameters.BackBufferFormat = Manager.Adapters.Default.CurrentDisplayMode.Format;
                presentParameters.BackBufferCount = 1;
            }
            presentParameters.DeviceWindowHandle = this.Handle;
            presentParameters.SwapEffect = SwapEffect.Discard;

            presentParameters.EnableAutoDepthStencil = true;
            presentParameters.AutoDepthStencilFormat = DepthFormat.D16;

            // FSAAx4ZbgigȂ̂ŒӁj
            presentParameters.MultiSample = MultiSampleType.FourSamples;
            presentParameters.MultiSampleQuality = 0;

            presentParameters.FullScreenRefreshRateInHz = 0;
            presentParameters.PresentationInterval = PresentInterval.Default;
            #endregion

            // Direct3D foCX̐
            this.device = new Device(
                Manager.Adapters.Default.Adapter,
                DeviceType.Hardware,
                this.Handle,
                CreateFlags.HardwareVertexProcessing, presentParameters);

            // foCXZbg̃Cxgnh̐ݒ
            this.device.DeviceReset += new System.EventHandler(this.OnResetDevice);

            // foCXXg̃Cxgnh̐ݒ
            this.device.DeviceLost += new System.EventHandler(this.OnLostDevice);

            // foCXTCỸCxgnh̐ݒ
            this.device.DeviceResizing += new System.ComponentModel.CancelEventHandler(OnDeviceResizing);

            // \[Xmۂ̂߂ɈӐ}IɃfoCXZbgCxgs
            this.OnResetDevice(this,null);
        }

        /// <summary>
        /// OtBbNX֘A\[X
        /// </summary>
        public void TerminateGraphics()
        {
            // \[XĴ߂ɈӐ}IɃfoCXZbgCxgs
            OnLostDevice(this, null);

            // Direct3D foCX̃\[X
            if (this.device != null)
            {
                this.device.Dispose();
                this.device = null;
            }
        }

        /// <summary>
        /// foCXTCỸCxgnh
        /// </summary>
        private static void OnDeviceResizing(object sender, System.ComponentModel.CancelEventArgs e)
        {
            e.Cancel = true;
        }

        /// <summary>
        ///  foCXXg̃Cxgnh
        /// </summary>
        private void OnLostDevice(object sender, EventArgs e)
        {
            if (font != null)
                font.Dispose();
            font = null;
        }

        /// <summary>
        ///  foCXZbg̃Cxgnh
        /// </summary>
        private void OnResetDevice(object sender, EventArgs e)
        {
            ///// tHg̍쐬 /////
            FontDescription fontDescription = new FontDescription();
            fontDescription.Height = 32;
            fontDescription.FaceName = "Arial";
            fontDescription.Quality = FontQuality.ClearType;

            // tHg쐬
            font = new Microsoft.DirectX.Direct3D.Font(this.device, fontDescription);

            ///// bV̍쐬 /////
            // ̂̍쐬
            boxMesh = createTransformableBoxMesh();

            ///// eNX`̍쐬 /////
            // t@Cǂݍ
        	diffTex =
                    TextureLoader.FromFile(
					this.device,
                    "wood.dds",
					0,0,0,
					Usage.None,
					Format.A8B8G8R8,
					Pool.Default,
					Filter.Triangle | Filter.Mirror,
                    Filter.Box,
                    0
					);

            string error;
            // GtFNgt@Cǂݍ
            ShaderFlags flag = ShaderFlags.None;
            effect = Effect.FromFile(
                this.device, "base.fx", null, null, flag, null, out error);
            if (effect == null)
            {
                MessageBox.Show(error);
                return;
            }
            // eNjbNw
            effect.Technique = "Fixed";
        }

        /// <summary>
        /// ڋԊxNgQ_\
        /// </summary>
        struct VertexTNB
        {
            public Vector3 Position;	// ʒu
            public Vector3 Tangent; 	// ڐ
            public Vector3 Normal;		// @
            public Vector3 Binormal;	// ]@
        }

        /// <summary>
        /// ό`\ȗ̂̃bV쐬
        /// </summary>
        private Mesh createTransformableBoxMesh()
        {
            #region CfbNXf[^̔z쐬
            Int16[] indexData ={
                        2,1,0,1,2,3,
                        5,6,4,6,5,7,
                        0,1,4,5,4,1,
                        6,3,2,7,3,6,
                        4,2,0,2,4,6,
                        1,3,5,7,5,3,
                      };
            #endregion

            #region x[X_f[^
            Vector3[] bpos = 
            {
                new Vector3(1, 1, 1),
                new Vector3(1, 1, -1),
                new Vector3(1, -1, 1),
                new Vector3(1, -1, -1),
                new Vector3(-1, 1, 1),
                new Vector3(-1, 1, -1),
                new Vector3(-1, -1, 1),
                new Vector3(-1, -1, -1)
            };
            #endregion

            #region @xNg
            Vector3[] bNormals =
            {
                new Vector3( 0, 0,-1),
			    new Vector3(-1, 0, 0),
			    new Vector3( 1, 0, 0),
			    new Vector3( 0, 1, 0),
			    new Vector3( 0,-1, 0),
			    new Vector3( 0, 0, 1)
            };
            #endregion

            #region ڐxNg
            Vector3[] bTangents =
            {
		        new Vector3( 1, 0, 0),
			    new Vector3( 0, 0,-1),
			    new Vector3( 0, 0, 1),
			    new Vector3( 1, 0, 0),
			    new Vector3( 1, 0, 0),
			    new Vector3(-1, 0, 0)
            };
            #endregion

            #region ]@xNg
            Vector3[] bBinormals =
            {
                new Vector3( 0, 1, 0),
			    new Vector3( 0, 1, 0),
			    new Vector3( 0, 1, 0),
			    new Vector3( 0, 0,-1),
			    new Vector3( 0, 0, 1),
			    new Vector3( 0, 1, 0)
            };
            #endregion

            //_f[^̔z쐬
            VertexTNB[] verts = new VertexTNB[36];

            #region CfbNX璸_WJ
            for (int t = 0; t < verts.Length/3; t++)
            {
                Vector3[] apex = new Vector3[3];

                // Op`PʂŒ_Zbg
                for (int a = 0; a < 3; a++)
                {
                    int n = t * 3 + a;
                    apex[a] = bpos[indexData[n]];
                    verts[n].Position = apex[a];
                }

                // @xNg̎Zo
                Vector3 normal = Vector3.Normalize(
                    Vector3.Cross(
                    Vector3.Normalize(apex[1] - apex[0]),
                    Vector3.Normalize(apex[2] - apex[0]))
                    );

                // ʎZo
                int basis = 0;
                float max_a = -1.0f;
                for (int n = 0; n < 6; n++)
                {
                    // @xNgɊʂZo
                    float a = Vector3.Dot(normal, bNormals[n]);
                    if (max_a < a)
                    {
                        max_a = a;
                        basis = n;
                    }
                }

                // @vZ
                for (int a = 0; a < 3; a++)
                {
                    int n = t * 3 + a;
                    verts[n].Normal = normal;
                    verts[n].Tangent = bTangents[basis];
                    verts[n].Binormal = bBinormals[basis];
                }
            }
            #endregion

            #region _vf̍쐬
            DeclarationType f3 = DeclarationType.Float3;
            DeclarationMethod dd = DeclarationMethod.Default;
            VertexElement[] elements =
		    {
			    new VertexElement(0, 0,  f3, dd, DeclarationUsage.Position, 0),
			    new VertexElement(0, 12, f3, dd, DeclarationUsage.Tangent, 0),
			    new VertexElement(0, 24, f3, dd, DeclarationUsage.Normal, 0),
			    new VertexElement(0, 36, f3, dd, DeclarationUsage.BiNormal, 0),
			    VertexElement.VertexDeclarationEnd,
		    };
            #endregion

            //bV̍쐬
            Mesh mesh = new Mesh(
					12, // Op`̐
					36, // _̐
					MeshFlags.Managed,
					elements,
					this.device );

            //_obt@ɏ݊Jn
			VertexBuffer vb = mesh.VertexBuffer;
            GraphicsStream vbuf = vb.Lock(0,0,LockFlags.None);
            vbuf.Write(verts);
            vb.Unlock();

            //obt@ɏ݊Jn
			IndexBuffer ib = mesh.IndexBuffer;
            GraphicsStream ibuf = ib.Lock(0,0,LockFlags.None);
            for(int n=0;n<verts.Length;n++)
            {
                ibuf.Write((Int16)n);
            }
			ib.Unlock();

            return mesh;
        }

        /// <summary>
        /// ɕ`R[h
        /// </summary>
        protected override void OnPaint(PaintEventArgs e)
        {
            // `e𔒂ŃNAAyobt@NAB
            this.device.Clear(ClearFlags.ZBuffer | ClearFlags.Target,
                Color.White, 1.0f, 0);

            // GtFNgĂȂȂ炱̕`͒߂
            if(effect==null) return;

            // uBeginScenevƁuEndScenev̊Ԃɕ`eLq
            this.device.BeginScene();

            ///// J̐ݒ /////
            Matrix vM =
                Matrix.RotationY(-(float)Math.PI*0.15f)
              * Matrix.RotationX(-(float)Math.PI*0.1f)
              * Matrix.Translation(0,0,20);
            Matrix pM =
                Matrix.PerspectiveFovLH(
                    Geometry.DegreeToRadian(30.0f),
                    (float)ClientSize.Width / (float)ClientSize.Height,
                    0.01f, 100.0f);

            // eNX`Zbg
            effect.SetValue("diffTex", this.diffTex);

            // F̐ݒ
            effect.SetValue("cDiffuse", new Vector4(1,1,1,1));

            float[] values = {0.8f ,1.4f, 3, 2.5f, 1.7f, 0.6f};

            // o[\
            for(int n=0;n<values.Length;n++)
            {
                drawMesh(boxMesh,
                    Matrix.Translation((-2+n)*2.5f,values[n]-2.0f,0),vM,pM,
                    new Vector4(1,values[n],0.25f,1));
            }

   
            // ̕\
            // W x=20 y=20 ̈ʒuɍŕ\
            font.DrawText(null, "Bar Chart", 20, 20, Color.Black);

            this.device.EndScene();

            #region V[̍XV
            try
            {
                this.device.Present();
            }
            // foCX̃`FbNƃZbg
            catch (DeviceLostException)
            {
                int result;
                // Zbg\ǂ`FbN
                if (!this.device.CheckCooperativeLevel(out result))
                {
                    // Zbg\Ȃ烊Zbg
                    if (result == (int)ResultCode.DeviceNotReset)
                        this.device.Reset(presentParameters);
                    // ܂ZbgłȂ΁A΂炭X[v
                    else if (result == (int)ResultCode.DeviceLost)
                        System.Threading.Thread.Sleep(20);
                }
            }
            #endregion
        }

        /// <summary>
        /// bV̕`
        /// </summary>
        /// <param name="mesh">bV</param>
        /// <param name="wM">[hWn</param>
        /// <param name="vM">r[Wn</param>
        /// <param name="pM">eWn</param>
        /// <param name="scale">XP[</param>
        protected void drawMesh(Mesh mesh,Matrix wM,Matrix vM,Matrix pM,Vector4 scale)
        {
            // 傫Zbg
            effect.SetValue("vScale", scale);

            // Wϊs̐ݒ
            effect.SetValue("mWV", wM * vM);
            effect.SetValue("mWVP", wM * vM * pM);

            int nPasses = 1;
            nPasses = effect.Begin(0);

            // _Oi`j
            for (int i = 0; i < nPasses; i++)
            {
                effect.BeginPass(i);
                effect.CommitChanges();
                mesh.DrawSubset( 0 );
                effect.EndPass();
            }
        }

    }
}